SystemOrganization addCategory: #Juegos!

Matrix subclass: #TresEnRayaLogica
	instanceVariableNames: 'cont simbolo ganador'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Juegos'!

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:20'!
actualizaEnFila: r Columna: c
 simbolo == nil
 ifTrue:[ simbolo := 'X'. ]
 ifFalse:[
	 		simbolo == 'X'
 		 	ifTrue: [ simbolo := 'O'. ]
			ifFalse: [ simbolo := 'X'. ]
		 ].
self at: r at: c put: simbolo . 
cont := cont  + 1.  
^simbolo.! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:33'!
checkArreglo: arr
arr size == 1
ifTrue: [ (arr includes: 'X')
		 	 ifTrue: [ganador := 'J1'. Transcript open. Transcript show: 'El jugador 1 gana'.].
		  (arr includes: 'O')   
  			  ifTrue: [ganador := 'J2'.  Transcript open. Transcript show: 'El jugador 2 gana'.]. ].! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:34'!
checkColumnas: colNum
| set |
 ganador  isNil
 ifTrue: [ set := (self atColumn: colNum) asSet.
  		  self checkArreglo: set. ].
^ganador.! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:32'!
checkDiagonales
| set1 set2 |
ganador isNil
 ifTrue: [set1 := (self diagonal) asSet.
 	 	set2 := Set newFrom: {(self at: 1 at: 3). (self at: 2 at: 2). (self at: 3 at: 1)} asOrderedCollection.
  		self checkArreglo: set1.
		self checkArreglo: set2.	].
^ganador.! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:32'!
checkFilas: numFila
| set |
 ganador  isNil
 ifTrue: [ set := (self atRow: numFila) asSet.
		  self checkArreglo: set  ].
^ganador.! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:29'!
checkGanador
 cont >= 5 "Despues de 5 turnos verificamos si hay ganador"
 ifTrue: [
  		Transcript show: 'Yes'.
		 1 to: 3 do: [:idx |	self checkFilas: idx.   
					   		 self checkColumnas: idx. ].
		 self checkDiagonales. ].! !

!TresEnRayaLogica methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:17'!
initialize 
	super initialize.
	cont  := 0.
	simbolo := nil.
	ganador := nil.! !

Object subclass: #TresEnRaya
	instanceVariableNames: 'contenedor modelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Juegos'!

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 00:27'!
addControles
| filaSup botonNuevo botonSalir |
 filaSup := Morph new layoutPolicy: RowLayout new;  color: Color transparent .
 botonNuevo := self crearBoton: 'Nuevo' onClickExecutes: [self reiniciar].
 botonSalir := self crearBoton: 'Salir' onClickExecutes: [contenedor delete].

 filaSup addMorph: botonSalir.
 filaSup addMorph: botonNuevo.
 contenedor addMorph: filaSup .! !

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 00:26'!
addFilas
| fila celda |
1 to:3  do: [ :fil |  fila := Morph new layoutPolicy: RowLayout new.
				   1 to: 3 do: [ :col  |  celda := TresEnRayaCelda new.
	       				  			   celda setModelo: (modelo) fila: fil columna: col.
   			 			 			   fila addMorph: celda. ].
  		     		  contenedor addMorph: fila. ]! !

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 00:40'!
crearBoton: label onClickExecutes: bloque
| boton |
 boton := SimpleButtonMorph new label: label.
 boton color: (Color r:255 g:1 b:1  alpha: 0.9).
 boton extent: 60@35.
 boton on: #click send: #value to: bloque.
^boton.! !

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/27/2012 23:41'!
initialize 
 contenedor := Morph new 
           			layoutPolicy: TableLayout new; 
              		color: Color transparent .
 modelo := TresEnRayaLogica new:3.
 self addFilas.
 self addControles.
^self.! !

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/27/2012 23:20'!
open 
 contenedor openInWorld.! !

!TresEnRaya methodsFor: 'as yet unclassified' stamp: 'alexz 9/27/2012 23:27'!
reiniciar
 contenedor delete.
 Smalltalk garbageCollect.
 TresEnRaya new open.! !

SimpleButtonMorph subclass: #TresEnRayaCelda
	instanceVariableNames: 'filNum colNum miModelo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Juegos'!

!TresEnRayaCelda methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 01:29'!
ejecutaOnClick
^[ (self label size) == 0
    ifTrue: [ self label: (miModelo  actualizaEnFila: filNum Columna: colNum).
	   	    miModelo checkGanador.
	          self extent: 40@40. ].
 ]
! !

!TresEnRayaCelda methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 00:47'!
initialize 
 super initialize.
 self label: ''.
 self extent: 40@40.
 self color: Color paleGreen.
 self borderWidth: 2.
 self on: #click send: #value to: (self ejecutaOnClick). 
^self.! !

!TresEnRayaCelda methodsFor: 'as yet unclassified' stamp: 'alexz 9/28/2012 00:31'!
setModelo: modelo fila: fil columna: col
 miModelo := modelo.
 filNum := fil.
 colNum := col.! !
